Range Area + Line Combo in JavaScript

Using ApexCharts with JavaScript

This Range Area + Line Combo example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [
    {
      type: 'rangeArea',
      name: 'Organic Range',

      data: [
        {
          x: 'Jan',
          y: [1100, 1900],
        },
        {
          x: 'Feb',
          y: [1200, 1800],
        },
        {
          x: 'Mar',
          y: [900, 2900],
        },
        {
          x: 'Apr',
          y: [1400, 2700],
        },
        {
          x: 'May',
          y: [2600, 3900],
        },
        {
          x: 'Jun',
          y: [500, 1700],
        },
        {
          x: 'Jul',
          y: [1900, 2300],
        },
        {
          x: 'Aug',
          y: [1000, 1500],
        },
      ],
    },

    {
      type: 'rangeArea',
      name: 'Paid Range',
      data: [
        {
          x: 'Jan',
          y: [3100, 3400],
        },
        {
          x: 'Feb',
          y: [4200, 5200],
        },
        {
          x: 'Mar',
          y: [3900, 4900],
        },
        {
          x: 'Apr',
          y: [3400, 3900],
        },
        {
          x: 'May',
          y: [5100, 5900],
        },
        {
          x: 'Jun',
          y: [5400, 6700],
        },
        {
          x: 'Jul',
          y: [4300, 4600],
        },
        {
          x: 'Aug',
          y: [2100, 2900],
        },
      ],
    },

    {
      type: 'line',
      name: 'Organic Median',
      data: [
        {
          x: 'Jan',
          y: 1500,
        },
        {
          x: 'Feb',
          y: 1700,
        },
        {
          x: 'Mar',
          y: 1900,
        },
        {
          x: 'Apr',
          y: 2200,
        },
        {
          x: 'May',
          y: 3000,
        },
        {
          x: 'Jun',
          y: 1000,
        },
        {
          x: 'Jul',
          y: 2100,
        },
        {
          x: 'Aug',
          y: 1200,
        },
        {
          x: 'Sep',
          y: 1800,
        },
        {
          x: 'Oct',
          y: 2000,
        },
      ],
    },
    {
      type: 'line',
      name: 'Paid Median',
      data: [
        {
          x: 'Jan',
          y: 3300,
        },
        {
          x: 'Feb',
          y: 4900,
        },
        {
          x: 'Mar',
          y: 4300,
        },
        {
          x: 'Apr',
          y: 3700,
        },
        {
          x: 'May',
          y: 5500,
        },
        {
          x: 'Jun',
          y: 5900,
        },
        {
          x: 'Jul',
          y: 4500,
        },
        {
          x: 'Aug',
          y: 2400,
        },
        {
          x: 'Sep',
          y: 2100,
        },
        {
          x: 'Oct',
          y: 1500,
        },
      ],
    },
  ],
  chart: {
    height: 350,
    type: 'rangeArea',
    animations: {
      speed: 500,
    },
  },
  colors: ['#d4526e', '#33b2df', '#d4526e', '#33b2df'],
  dataLabels: {
    enabled: false,
  },
  fill: {
    opacity: [0.24, 0.24, 1, 1],
  },
  forecastDataPoints: {
    count: 2,
  },
  stroke: {
    curve: 'straight',
    width: [0, 0, 2, 2],
  },
  legend: {
    show: true,
    customLegendItems: ['Organic', 'Paid'],
    inverseOrder: true,
  },
  title: {
    text: 'Daily Visitors: Range & Median with Forecast',
  },
  markers: {
    hover: {
      sizeOffset: 5,
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Range Area + Line Combo in React

Using ApexCharts with React

This Range Area + Line Combo example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        type: 'rangeArea',
        name: 'Organic Range',

        data: [
          {
            x: 'Jan',
            y: [1100, 1900],
          },
          {
            x: 'Feb',
            y: [1200, 1800],
          },
          {
            x: 'Mar',
            y: [900, 2900],
          },
          {
            x: 'Apr',
            y: [1400, 2700],
          },
          {
            x: 'May',
            y: [2600, 3900],
          },
          {
            x: 'Jun',
            y: [500, 1700],
          },
          {
            x: 'Jul',
            y: [1900, 2300],
          },
          {
            x: 'Aug',
            y: [1000, 1500],
          },
        ],
      },

      {
        type: 'rangeArea',
        name: 'Paid Range',
        data: [
          {
            x: 'Jan',
            y: [3100, 3400],
          },
          {
            x: 'Feb',
            y: [4200, 5200],
          },
          {
            x: 'Mar',
            y: [3900, 4900],
          },
          {
            x: 'Apr',
            y: [3400, 3900],
          },
          {
            x: 'May',
            y: [5100, 5900],
          },
          {
            x: 'Jun',
            y: [5400, 6700],
          },
          {
            x: 'Jul',
            y: [4300, 4600],
          },
          {
            x: 'Aug',
            y: [2100, 2900],
          },
        ],
      },

      {
        type: 'line',
        name: 'Organic Median',
        data: [
          {
            x: 'Jan',
            y: 1500,
          },
          {
            x: 'Feb',
            y: 1700,
          },
          {
            x: 'Mar',
            y: 1900,
          },
          {
            x: 'Apr',
            y: 2200,
          },
          {
            x: 'May',
            y: 3000,
          },
          {
            x: 'Jun',
            y: 1000,
          },
          {
            x: 'Jul',
            y: 2100,
          },
          {
            x: 'Aug',
            y: 1200,
          },
          {
            x: 'Sep',
            y: 1800,
          },
          {
            x: 'Oct',
            y: 2000,
          },
        ],
      },
      {
        type: 'line',
        name: 'Paid Median',
        data: [
          {
            x: 'Jan',
            y: 3300,
          },
          {
            x: 'Feb',
            y: 4900,
          },
          {
            x: 'Mar',
            y: 4300,
          },
          {
            x: 'Apr',
            y: 3700,
          },
          {
            x: 'May',
            y: 5500,
          },
          {
            x: 'Jun',
            y: 5900,
          },
          {
            x: 'Jul',
            y: 4500,
          },
          {
            x: 'Aug',
            y: 2400,
          },
          {
            x: 'Sep',
            y: 2100,
          },
          {
            x: 'Oct',
            y: 1500,
          },
        ],
      },
    ],
    options: {
      chart: {
        height: 350,
        type: 'rangeArea',
        animations: {
          speed: 500,
        },
      },
      colors: ['#d4526e', '#33b2df', '#d4526e', '#33b2df'],
      dataLabels: {
        enabled: false,
      },
      fill: {
        opacity: [0.24, 0.24, 1, 1],
      },
      forecastDataPoints: {
        count: 2,
      },
      stroke: {
        curve: 'straight',
        width: [0, 0, 2, 2],
      },
      legend: {
        show: true,
        customLegendItems: ['Organic', 'Paid'],
        inverseOrder: true,
      },
      title: {
        text: 'Daily Visitors: Range & Median with Forecast',
      },
      markers: {
        hover: {
          sizeOffset: 5,
        },
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="rangeArea"
          height={350}
        />
      </div>
    </div>
  )
}

export default ApexChart

Range Area + Line Combo in Vue

Using ApexCharts with Vue

This Range Area + Line Combo example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="rangeArea"
        height="350"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          type: 'rangeArea',
          name: 'Organic Range',

          data: [
            {
              x: 'Jan',
              y: [1100, 1900],
            },
            {
              x: 'Feb',
              y: [1200, 1800],
            },
            {
              x: 'Mar',
              y: [900, 2900],
            },
            {
              x: 'Apr',
              y: [1400, 2700],
            },
            {
              x: 'May',
              y: [2600, 3900],
            },
            {
              x: 'Jun',
              y: [500, 1700],
            },
            {
              x: 'Jul',
              y: [1900, 2300],
            },
            {
              x: 'Aug',
              y: [1000, 1500],
            },
          ],
        },

        {
          type: 'rangeArea',
          name: 'Paid Range',
          data: [
            {
              x: 'Jan',
              y: [3100, 3400],
            },
            {
              x: 'Feb',
              y: [4200, 5200],
            },
            {
              x: 'Mar',
              y: [3900, 4900],
            },
            {
              x: 'Apr',
              y: [3400, 3900],
            },
            {
              x: 'May',
              y: [5100, 5900],
            },
            {
              x: 'Jun',
              y: [5400, 6700],
            },
            {
              x: 'Jul',
              y: [4300, 4600],
            },
            {
              x: 'Aug',
              y: [2100, 2900],
            },
          ],
        },

        {
          type: 'line',
          name: 'Organic Median',
          data: [
            {
              x: 'Jan',
              y: 1500,
            },
            {
              x: 'Feb',
              y: 1700,
            },
            {
              x: 'Mar',
              y: 1900,
            },
            {
              x: 'Apr',
              y: 2200,
            },
            {
              x: 'May',
              y: 3000,
            },
            {
              x: 'Jun',
              y: 1000,
            },
            {
              x: 'Jul',
              y: 2100,
            },
            {
              x: 'Aug',
              y: 1200,
            },
            {
              x: 'Sep',
              y: 1800,
            },
            {
              x: 'Oct',
              y: 2000,
            },
          ],
        },
        {
          type: 'line',
          name: 'Paid Median',
          data: [
            {
              x: 'Jan',
              y: 3300,
            },
            {
              x: 'Feb',
              y: 4900,
            },
            {
              x: 'Mar',
              y: 4300,
            },
            {
              x: 'Apr',
              y: 3700,
            },
            {
              x: 'May',
              y: 5500,
            },
            {
              x: 'Jun',
              y: 5900,
            },
            {
              x: 'Jul',
              y: 4500,
            },
            {
              x: 'Aug',
              y: 2400,
            },
            {
              x: 'Sep',
              y: 2100,
            },
            {
              x: 'Oct',
              y: 1500,
            },
          ],
        },
      ],
      chartOptions: {
        chart: {
          height: 350,
          type: 'rangeArea',
          animations: {
            speed: 500,
          },
        },
        colors: ['#d4526e', '#33b2df', '#d4526e', '#33b2df'],
        dataLabels: {
          enabled: false,
        },
        fill: {
          opacity: [0.24, 0.24, 1, 1],
        },
        forecastDataPoints: {
          count: 2,
        },
        stroke: {
          curve: 'straight',
          width: [0, 0, 2, 2],
        },
        legend: {
          show: true,
          customLegendItems: ['Organic', 'Paid'],
          inverseOrder: true,
        },
        title: {
          text: 'Daily Visitors: Range & Median with Forecast',
        },
        markers: {
          hover: {
            sizeOffset: 5,
          },
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>

Range Area + Line Combo in Angular

Using ApexCharts with Angular

This Range Area + Line Combo example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              type: 'rangeArea',
              name: 'Organic Range',
  
              data: [
                {
                  x: 'Jan',
                  y: [1100, 1900],
                },
                {
                  x: 'Feb',
                  y: [1200, 1800],
                },
                {
                  x: 'Mar',
                  y: [900, 2900],
                },
                {
                  x: 'Apr',
                  y: [1400, 2700],
                },
                {
                  x: 'May',
                  y: [2600, 3900],
                },
                {
                  x: 'Jun',
                  y: [500, 1700],
                },
                {
                  x: 'Jul',
                  y: [1900, 2300],
                },
                {
                  x: 'Aug',
                  y: [1000, 1500],
                },
              ],
            },
  
            {
              type: 'rangeArea',
              name: 'Paid Range',
              data: [
                {
                  x: 'Jan',
                  y: [3100, 3400],
                },
                {
                  x: 'Feb',
                  y: [4200, 5200],
                },
                {
                  x: 'Mar',
                  y: [3900, 4900],
                },
                {
                  x: 'Apr',
                  y: [3400, 3900],
                },
                {
                  x: 'May',
                  y: [5100, 5900],
                },
                {
                  x: 'Jun',
                  y: [5400, 6700],
                },
                {
                  x: 'Jul',
                  y: [4300, 4600],
                },
                {
                  x: 'Aug',
                  y: [2100, 2900],
                },
              ],
            },
  
            {
              type: 'line',
              name: 'Organic Median',
              data: [
                {
                  x: 'Jan',
                  y: 1500,
                },
                {
                  x: 'Feb',
                  y: 1700,
                },
                {
                  x: 'Mar',
                  y: 1900,
                },
                {
                  x: 'Apr',
                  y: 2200,
                },
                {
                  x: 'May',
                  y: 3000,
                },
                {
                  x: 'Jun',
                  y: 1000,
                },
                {
                  x: 'Jul',
                  y: 2100,
                },
                {
                  x: 'Aug',
                  y: 1200,
                },
                {
                  x: 'Sep',
                  y: 1800,
                },
                {
                  x: 'Oct',
                  y: 2000,
                },
              ],
            },
            {
              type: 'line',
              name: 'Paid Median',
              data: [
                {
                  x: 'Jan',
                  y: 3300,
                },
                {
                  x: 'Feb',
                  y: 4900,
                },
                {
                  x: 'Mar',
                  y: 4300,
                },
                {
                  x: 'Apr',
                  y: 3700,
                },
                {
                  x: 'May',
                  y: 5500,
                },
                {
                  x: 'Jun',
                  y: 5900,
                },
                {
                  x: 'Jul',
                  y: 4500,
                },
                {
                  x: 'Aug',
                  y: 2400,
                },
                {
                  x: 'Sep',
                  y: 2100,
                },
                {
                  x: 'Oct',
                  y: 1500,
                },
              ],
            },
          ],
          chart: {
            height: 350,
            type: 'rangeArea',
            animations: {
              speed: 500,
            },
          },
          colors: ['#d4526e', '#33b2df', '#d4526e', '#33b2df'],
          dataLabels: {
            enabled: false,
          },
          fill: {
            opacity: [0.24, 0.24, 1, 1],
          },
          forecastDataPoints: {
            count: 2,
          },
          stroke: {
            curve: 'straight',
            width: [0, 0, 2, 2],
          },
          legend: {
            show: true,
            customLegendItems: ['Organic', 'Paid'],
            inverseOrder: true,
          },
          title: {
            text: 'Daily Visitors: Range & Median with Forecast',
          },
          markers: {
            hover: {
              sizeOffset: 5,
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}